<?php
// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2011 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

function plugin_install($plugin_id, $plugin_version, &$errors) {
  global $conf, $prefixeTable;
  load_language('plugin.lang', dirname(__FILE__).'/');
  
  // Check if the copyrights plugin is there
  $query = '
    SELECT `id`
	FROM '.$prefixeTable.'plugins
	WHERE id=\'Copyrights\'
    ;';
  $result = pwg_query($query);
  // if not, cancel the install
  if (!pwg_db_fetch_assoc($result)) {
	$msg = l10n('To install this plugin, you need to install the <a href="http://piwigo.org/ext/extension_view.php?eid=537">Copyrights plugin</a> first.');
	if(is_array($errors)) {
	  array_push($errors, $msg);
	} else {
	  $errors=Array($msg);
	}
	return false;
  }
  
  // Create the author table
  $query = '
    CREATE TABLE IF NOT EXISTS '.$prefixeTable.'author_extended (
	  author_id int(11) NOT NULL AUTO_INCREMENT,
      name varchar(255) UNIQUE NOT NULL,
	  code varchar (4) UNIQUE NOT NULL,
      url varchar(255),
      descr text DEFAULT NULL,
	  copyright int(11) DEFAULT NULL,
      PRIMARY KEY (author_id)
    ) ENGINE=MyISAM DEFAULT CHARACTER SET utf8
    ;';
  pwg_query($query);
  
  // Temporary disable the auto increment
  $query = '
	ALTER TABLE '.$prefixeTable.'copyrights_admin
	MODIFY cr_id int(11) NOT NULL
    ;';
  pwg_query($query);
  // Insert "author's default copyright" in the copyrights table. On duplicates, it does nothing.
  $query = '
	INSERT INTO '.$prefixeTable.'copyrights_admin
	VALUES (-1, \'Author\'\'s default copyright\', \'\', \'This is the default copyright for an author.\', 1)
	ON DUPLICATE KEY UPDATE cr_id = -1
    ;';
  pwg_query($query);
  // Reenable the auto increment
  $query = '
	ALTER TABLE '.$prefixeTable.'copyrights_admin
	MODIFY cr_id int(11) NOT NULL AUTO_INCREMENT
    ;';
  pwg_query($query);
}

function plugin_uninstall() {
  global $prefixeTable;
  
  // Drop the author table
  $query = '
    DROP TABLE '.$prefixeTable.'author_extended
    ;';
  pwg_query($query);
  
  // Remove the default copyright from the admin table
  $query = '
    DELETE
    FROM '.$prefixeTable.'copyrights_admin
    WHERE cr_id = -1
    ;';
  pwg_query($query);
  
  // And remove all default copyrights from the media table
  $query = '
    DELETE
    FROM '.$prefixeTable.'copyrights_media
    WHERE cr_id = -1
    ;';
  pwg_query($query);  
}

?>